diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/fd-net-device/helper/tap-fd-net-device-helper.cc ns-3.42/src/fd-net-device/helper/tap-fd-net-device-helper.cc
--- ns-3.41/src/fd-net-device/helper/tap-fd-net-device-helper.cc	2024-02-09 14:44:07.909790000 -0800
+++ ns-3.42/src/fd-net-device/helper/tap-fd-net-device-helper.cc	2024-05-29 15:29:46.948073100 -0700
@@ -349,7 +349,7 @@
         // an "ancillary element" but the msghdr uses the control message termimology
         // so we call it "control."
         //
-        size_t msg_size = sizeof(int);
+        constexpr size_t msg_size = sizeof(int);
         char control[CMSG_SPACE(msg_size)];
 
         //
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/fd-net-device/model/fd-net-device.cc ns-3.42/src/fd-net-device/model/fd-net-device.cc
--- ns-3.41/src/fd-net-device/model/fd-net-device.cc	2024-02-09 14:44:07.909790000 -0800
+++ ns-3.42/src/fd-net-device/model/fd-net-device.cc	2024-05-29 15:29:46.948073100 -0700
@@ -752,7 +752,7 @@
 Address
 FdNetDevice::GetBroadcast() const
 {
-    return Mac48Address("ff:ff:ff:ff:ff:ff");
+    return Mac48Address::GetBroadcast();
 }
 
 bool
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/flow-monitor/examples/flowmon-parse-results.py ns-3.42/src/flow-monitor/examples/flowmon-parse-results.py
--- ns-3.41/src/flow-monitor/examples/flowmon-parse-results.py	2024-02-09 14:44:07.909790000 -0800
+++ ns-3.42/src/flow-monitor/examples/flowmon-parse-results.py	2024-05-29 15:29:46.952073000 -0700
@@ -1,5 +1,3 @@
-from __future__ import division
-
 import os
 import sys
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/flow-monitor/examples/wifi-olsr-flowmon.py ns-3.42/src/flow-monitor/examples/wifi-olsr-flowmon.py
--- ns-3.41/src/flow-monitor/examples/wifi-olsr-flowmon.py	2024-02-09 14:44:07.909790000 -0800
+++ ns-3.42/src/flow-monitor/examples/wifi-olsr-flowmon.py	2024-05-29 15:29:46.952073000 -0700
@@ -52,35 +52,31 @@
     cmd.AddValue("Plot", "Plot the results using the matplotlib python module", Plot)
     cmd.Parse(argv)
 
-    wifi = ns.CreateObject("WifiHelper")
-    wifiMac = ns.CreateObject("WifiMacHelper")
-    wifiPhy = ns.CreateObject("YansWifiPhyHelper")
-    wifiChannel = ns.wifi.YansWifiChannelHelper.Default()
+    wifi = ns.WifiHelper()
+    wifiMac = ns.WifiMacHelper()
+    wifiPhy = ns.YansWifiPhyHelper()
+    wifiChannel = ns.YansWifiChannelHelper.Default()
     wifiPhy.SetChannel(wifiChannel.Create())
-    ssid = ns.wifi.Ssid("wifi-default")
-    wifiMac.SetType("ns3::AdhocWifiMac", "Ssid", ns.wifi.SsidValue(ssid))
+    ssid = ns.Ssid("wifi-default")
+    wifiMac.SetType("ns3::AdhocWifiMac", "Ssid", ns.SsidValue(ssid))
 
-    internet = ns.internet.InternetStackHelper()
-    list_routing = ns.internet.Ipv4ListRoutingHelper()
-    olsr_routing = ns.olsr.OlsrHelper()
-    static_routing = ns.internet.Ipv4StaticRoutingHelper()
+    internet = ns.InternetStackHelper()
+    list_routing = ns.Ipv4ListRoutingHelper()
+    olsr_routing = ns.OlsrHelper()
+    static_routing = ns.Ipv4StaticRoutingHelper()
     list_routing.Add(static_routing, 0)
     list_routing.Add(olsr_routing, 100)
     internet.SetRoutingHelper(list_routing)
 
-    ipv4Addresses = ns.internet.Ipv4AddressHelper()
-    ipv4Addresses.SetBase(ns.network.Ipv4Address("10.0.0.0"), ns.network.Ipv4Mask("255.255.255.0"))
+    ipv4Addresses = ns.Ipv4AddressHelper()
+    ipv4Addresses.SetBase(ns.Ipv4Address("10.0.0.0"), ns.Ipv4Mask("255.255.255.0"))
 
     port = 9  # Discard port(RFC 863)
-    inetAddress = ns.network.InetSocketAddress(ns.network.Ipv4Address("10.0.0.1"), port)
-    onOffHelper = ns.applications.OnOffHelper("ns3::UdpSocketFactory", inetAddress.ConvertTo())
-    onOffHelper.SetAttribute("DataRate", ns.network.DataRateValue(ns.network.DataRate("100kbps")))
-    onOffHelper.SetAttribute(
-        "OnTime", ns.core.StringValue("ns3::ConstantRandomVariable[Constant=1]")
-    )
-    onOffHelper.SetAttribute(
-        "OffTime", ns.core.StringValue("ns3::ConstantRandomVariable[Constant=0]")
-    )
+    inetAddress = ns.InetSocketAddress(ns.Ipv4Address("10.0.0.1"), port)
+    onOffHelper = ns.OnOffHelper("ns3::UdpSocketFactory", inetAddress.ConvertTo())
+    onOffHelper.SetAttribute("DataRate", ns.DataRateValue(ns.DataRate("100kbps")))
+    onOffHelper.SetAttribute("OnTime", ns.StringValue("ns3::ConstantRandomVariable[Constant=1]"))
+    onOffHelper.SetAttribute("OffTime", ns.StringValue("ns3::ConstantRandomVariable[Constant=0]"))
 
     addresses = []
     nodes = []
@@ -96,11 +92,11 @@
         for yi in range(num_nodes_side):
             node = nodes.Get(accumulator)
             accumulator += 1
-            container = ns.network.NodeContainer(node)
+            container = ns.NodeContainer(node)
             internet.Install(container)
 
-            mobility = ns.CreateObject("ConstantPositionMobilityModel")
-            mobility.SetPosition(ns.core.Vector(xi * DISTANCE, yi * DISTANCE, 0))
+            mobility = ns.CreateObject[ns.ConstantPositionMobilityModel]()
+            mobility.SetPosition(ns.Vector(xi * DISTANCE, yi * DISTANCE, 0))
             node.AggregateObject(mobility)
 
             device = wifi.Install(wifiPhy, wifiMac, node)
@@ -112,25 +108,25 @@
         # print (i, destaddr)
         onOffHelper.SetAttribute(
             "Remote",
-            ns.network.AddressValue(ns.network.InetSocketAddress(destaddr, port).ConvertTo()),
+            ns.AddressValue(ns.InetSocketAddress(destaddr, port).ConvertTo()),
         )
-        container = ns.network.NodeContainer(node)
+        container = ns.NodeContainer(node)
         app = onOffHelper.Install(container)
-        urv = ns.CreateObject("UniformRandomVariable")  # ns.cppyy.gbl.get_rng()
+        urv = ns.CreateObject[ns.UniformRandomVariable]()  # ns.cppyy.gbl.get_rng()
         startDelay = ns.Seconds(urv.GetValue(20, 30))
         app.Start(startDelay)
 
     # internet.EnablePcapAll("wifi-olsr")
-    flowmon_helper = ns.flow_monitor.FlowMonitorHelper()
-    # flowmon_helper.SetMonitorAttribute("StartTime", ns.core.TimeValue(ns.core.Seconds(31)))
+    flowmon_helper = ns.FlowMonitorHelper()
+    # flowmon_helper.SetMonitorAttribute("StartTime", ns.TimeValue(ns.Seconds(31)))
     monitor = flowmon_helper.InstallAll()
     monitor = flowmon_helper.GetMonitor()
-    monitor.SetAttribute("DelayBinWidth", ns.core.DoubleValue(0.001))
-    monitor.SetAttribute("JitterBinWidth", ns.core.DoubleValue(0.001))
-    monitor.SetAttribute("PacketSizeBinWidth", ns.core.DoubleValue(20))
+    monitor.SetAttribute("DelayBinWidth", ns.DoubleValue(0.001))
+    monitor.SetAttribute("JitterBinWidth", ns.DoubleValue(0.001))
+    monitor.SetAttribute("PacketSizeBinWidth", ns.DoubleValue(20))
 
-    ns.core.Simulator.Stop(ns.core.Seconds(44.0))
-    ns.core.Simulator.Run()
+    ns.Simulator.Stop(ns.Seconds(44.0))
+    ns.Simulator.Run()
 
     def print_stats(os, st):
         print("  Tx Bytes: ", st.txBytes, file=os)
@@ -213,7 +209,7 @@
         print(res)
 
     if Plot.value:
-        import pylab
+        from matplotlib import pyplot as plt
 
         delays = []
         for flow_id, flow_stats in monitor.GetFlowStats():
@@ -221,10 +217,10 @@
             if tupl.protocol == 17 and tupl.sourcePort == 698:
                 continue
             delays.append(flow_stats.delaySum.GetSeconds() / flow_stats.rxPackets)
-        pylab.hist(delays, 20)
-        pylab.xlabel("Delay (s)")
-        pylab.ylabel("Number of Flows")
-        pylab.show()
+        plt.hist(delays, 20)
+        plt.xlabel("Delay (s)")
+        plt.ylabel("Number of Flows")
+        plt.show()
 
     return 0
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/internet/helper/internet-stack-helper.h ns-3.42/src/internet/helper/internet-stack-helper.h
--- ns-3.41/src/internet/helper/internet-stack-helper.h	2024-02-09 14:44:07.921790100 -0800
+++ ns-3.42/src/internet/helper/internet-stack-helper.h	2024-05-29 15:29:46.956073300 -0700
@@ -96,7 +96,7 @@
      * and global routing by default. The static routing protocol
      * (ns3::Ipv4StaticRouting) and the global routing protocol are
      * stored in an ns3::Ipv4ListRouting protocol with priorities 0, and -10
-     * by default. If you wish to use different priorites and different
+     * by default. If you wish to use different priorities and different
      * routing protocols, you need to use an adhoc ns3::Ipv4RoutingHelper,
      * such as ns3::OlsrHelper
      */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/internet/helper/ipv4-address-helper.cc ns-3.42/src/internet/helper/ipv4-address-helper.cc
--- ns-3.41/src/internet/helper/ipv4-address-helper.cc	2024-02-09 14:44:07.921790100 -0800
+++ ns-3.42/src/internet/helper/ipv4-address-helper.cc	2024-05-29 15:29:46.956073300 -0700
@@ -48,7 +48,7 @@
     m_mask = 0;
     m_address = 0xffffffff;
     m_base = 0xffffffff;
-    m_shift = 0xffffffff;
+    m_shift = 0;
     m_max = 0xffffffff;
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/internet/helper/neighbor-cache-helper.h ns-3.42/src/internet/helper/neighbor-cache-helper.h
--- ns-3.41/src/internet/helper/neighbor-cache-helper.h	2024-02-09 14:44:07.921790100 -0800
+++ ns-3.42/src/internet/helper/neighbor-cache-helper.h	2024-05-29 15:29:46.956073300 -0700
@@ -40,7 +40,7 @@
 {
 
 /**
- * \ingroup NeighborCacheHelper
+ * \ingroup internet
  *
  * @brief A helper class to populate neighbor cache.
  *
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/internet/model/arp-cache.h ns-3.42/src/internet/model/arp-cache.h
--- ns-3.41/src/internet/model/arp-cache.h	2024-02-09 14:44:07.921790100 -0800
+++ ns-3.42/src/internet/model/arp-cache.h	2024-05-29 15:29:46.956073300 -0700
@@ -314,7 +314,7 @@
         Address m_macAddress;         //!< entry's MAC address
         Ipv4Address m_ipv4Address;    //!< entry's IP address
         std::list<Ipv4PayloadHeaderPair> m_pending; //!< list of pending packets for the entry's IP
-        uint32_t m_retries;                         //!< rerty counter
+        uint32_t m_retries;                         //!< retry counter
     };
 
   private:
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/internet/model/arp-l3-protocol.cc ns-3.42/src/internet/model/arp-l3-protocol.cc
--- ns-3.41/src/internet/model/arp-l3-protocol.cc	2024-02-09 14:44:07.921790100 -0800
+++ ns-3.42/src/internet/model/arp-l3-protocol.cc	2024-05-29 15:29:46.956073300 -0700
@@ -261,7 +261,7 @@
                 else
                 {
                     // ignore this reply which might well be an attempt
-                    // at poisening my arp cache.
+                    // at poisoning my arp cache.
                     NS_LOG_LOGIC("node=" << m_node->GetId() << ", got reply from "
                                          << arp.GetSourceIpv4Address()
                                          << " for non-waiting entry -- drop");
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/internet/model/arp-queue-disc-item.cc ns-3.42/src/internet/model/arp-queue-disc-item.cc
--- ns-3.41/src/internet/model/arp-queue-disc-item.cc	2024-02-09 14:44:07.921790100 -0800
+++ ns-3.42/src/internet/model/arp-queue-disc-item.cc	2024-05-29 15:29:46.956073300 -0700
@@ -19,6 +19,8 @@
 
 #include "ns3/log.h"
 
+#include <vector>
+
 namespace ns3
 {
 
@@ -104,11 +106,11 @@
 
     /* serialize the addresses and the perturbation in buf */
     uint8_t tmp = 8 + macSrc.GetLength() + macDst.GetLength();
-    uint8_t buf[tmp + 5];
-    ipv4Src.Serialize(buf);
-    ipv4Dst.Serialize(buf + 4);
-    macSrc.CopyTo(buf + 8);
-    macDst.CopyTo(buf + 8 + macSrc.GetLength());
+    std::vector<uint8_t> buf(tmp + 5);
+    ipv4Src.Serialize(buf.data());
+    ipv4Dst.Serialize(buf.data() + 4);
+    macSrc.CopyTo(buf.data() + 8);
+    macDst.CopyTo(buf.data() + 8 + macSrc.GetLength());
     buf[tmp] = type;
     buf[tmp + 1] = (perturbation >> 24) & 0xff;
     buf[tmp + 2] = (perturbation >> 16) & 0xff;
@@ -118,7 +120,7 @@
     // Linux calculates jhash2 (jenkins hash), we calculate murmur3 because it is
     // already available in ns-3
 
-    uint32_t hash = Hash32((char*)buf, tmp + 5);
+    uint32_t hash = Hash32((char*)buf.data(), tmp + 5);
 
     NS_LOG_DEBUG("Hash value " << hash);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/internet/model/global-route-manager-impl.cc ns-3.42/src/internet/model/global-route-manager-impl.cc
--- ns-3.41/src/internet/model/global-route-manager-impl.cc	2024-02-09 14:44:07.921790100 -0800
+++ ns-3.42/src/internet/model/global-route-manager-impl.cc	2024-05-29 15:29:46.956073300 -0700
@@ -128,7 +128,7 @@
     NS_LOG_FUNCTION(this);
 
     NS_LOG_LOGIC("Children vertices - " << m_children);
-    NS_LOG_LOGIC("Parent verteices - " << m_parents);
+    NS_LOG_LOGIC("Parent vertices - " << m_parents);
 
     // find this node from all its parents and remove the entry of this node
     // from all its parents
@@ -284,7 +284,7 @@
     // always maintain only one root's exit
     m_ecmpRootExits.clear();
     m_ecmpRootExits.emplace_back(nextHop, id);
-    // update the following in order to be backward compatitable with
+    // update the following in order to be backward compatible with
     // GetNextHop and GetOutgoingInterface methods
     m_nextHop = nextHop;
     m_rootOif = id;
@@ -1023,7 +1023,7 @@
             //
             // In the case of point-to-point links, the link data field (m_linkData) of a
             // Global Router Link Record contains the local IP address.  If we look at the
-            // link record describing the link from the perspecive of <w> (the remote
+            // link record describing the link from the perspective of <w> (the remote
             // node from the viewpoint of <v>) back to the root node, we can discover the
             // IP address of the router to which <v> is adjacent.  This is a distinguished
             // address -- the next hop address to get from <v> to <w> and all networks
@@ -1254,12 +1254,8 @@
     for (uint32_t i = 0; i < rlsa->GetNLinkRecords(); i++)
     {
         GlobalRoutingLinkRecord* l = rlsa->GetLinkRecord(i);
-        if (l->GetLinkType() == GlobalRoutingLinkRecord::TransitNetwork)
-        {
-            transits++;
-            transitLink = l;
-        }
-        else if (l->GetLinkType() == GlobalRoutingLinkRecord::PointToPoint)
+        if (l->GetLinkType() == GlobalRoutingLinkRecord::TransitNetwork ||
+            l->GetLinkType() == GlobalRoutingLinkRecord::PointToPoint)
         {
             transits++;
             transitLink = l;
@@ -1972,7 +1968,7 @@
             //
             // Iterate through the link records on the vertex to which we're going to add
             // routes.  To make sure we're being clear, we're going to add routing table
-            // entries to the tables on the node corresping to the root of the SPF tree.
+            // entries to the tables on the node corresponding to the root of the SPF tree.
             // These entries will have routes to the IP addresses we find from looking at
             // the local side of the point-to-point links found on the node described by
             // the vertex <v>.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/internet/model/icmpv6-l4-protocol.cc ns-3.42/src/internet/model/icmpv6-l4-protocol.cc
--- ns-3.41/src/internet/model/icmpv6-l4-protocol.cc	2024-02-09 14:44:07.925790300 -0800
+++ ns-3.42/src/internet/model/icmpv6-l4-protocol.cc	2024-05-29 15:29:46.960073200 -0700
@@ -421,7 +421,7 @@
 {
     NS_LOG_FUNCTION(this << packet << src << dst << interface);
 
-    if (m_handleRsTimeoutEvent.IsRunning())
+    if (m_handleRsTimeoutEvent.IsPending())
     {
         m_handleRsTimeoutEvent.Cancel();
         // We need to update this in case we need to restart RS retransmissions.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/internet/model/icmpv6-l4-protocol.h ns-3.42/src/internet/model/icmpv6-l4-protocol.h
--- ns-3.41/src/internet/model/icmpv6-l4-protocol.h	2024-02-09 14:44:07.925790300 -0800
+++ ns-3.42/src/internet/model/icmpv6-l4-protocol.h	2024-05-29 15:29:46.960073200 -0700
@@ -395,7 +395,7 @@
 
     /**
      * \brief Create a neighbor cache.
-     * \param device thet NetDevice
+     * \param device the NetDevice
      * \param interface the IPv6 interface
      * \return a smart pointer of NdCache or 0 if problem
      */
@@ -642,7 +642,7 @@
     /**
      * \brief Multicast RS retransmissions counter [\RFC{7559}].
      *
-     * Zero indicate a first transmission, greater than zero means retranmsisisons.
+     * Zero indicate a first transmission, greater than zero means retransmissions.
      */
     uint32_t m_rsRetransmissionCount{0};
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/internet/model/ipv4-global-routing.h ns-3.42/src/internet/model/ipv4-global-routing.h
--- ns-3.41/src/internet/model/ipv4-global-routing.h	2024-02-09 14:44:07.925790300 -0800
+++ ns-3.42/src/internet/model/ipv4-global-routing.h	2024-05-29 15:29:46.960073200 -0700
@@ -239,7 +239,7 @@
     /// Set to true if packets are randomly routed among ECMP; set to false for using only one route
     /// consistently
     bool m_randomEcmpRouting;
-    /// Set to true if this interface should respond to interface events by globallly recomputing
+    /// Set to true if this interface should respond to interface events by globally recomputing
     /// routes
     bool m_respondToInterfaceEvents;
     /// A uniform random number generator for randomly routing packets among ECMP
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/internet/model/ipv4-l3-protocol.cc ns-3.42/src/internet/model/ipv4-l3-protocol.cc
--- ns-3.41/src/internet/model/ipv4-l3-protocol.cc	2024-02-09 14:44:07.929790300 -0800
+++ ns-3.42/src/internet/model/ipv4-l3-protocol.cc	2024-05-29 15:29:46.960073200 -0700
@@ -210,16 +210,12 @@
 Ptr<IpL4Protocol>
 Ipv4L3Protocol::GetProtocol(int protocolNumber) const
 {
-    NS_LOG_FUNCTION(this << protocolNumber);
-
     return GetProtocol(protocolNumber, -1);
 }
 
 Ptr<IpL4Protocol>
 Ipv4L3Protocol::GetProtocol(int protocolNumber, int32_t interfaceIndex) const
 {
-    NS_LOG_FUNCTION(this << protocolNumber << interfaceIndex);
-
     if (interfaceIndex >= 0)
     {
         // try the interface-specific protocol.
@@ -306,7 +302,6 @@
 Ptr<Ipv4RoutingProtocol>
 Ipv4L3Protocol::GetRoutingProtocol() const
 {
-    NS_LOG_FUNCTION(this);
     return m_routingProtocol;
 }
 
@@ -338,12 +333,12 @@
 
     m_fragments.clear();
     m_timeoutEventList.clear();
-    if (m_timeoutEvent.IsRunning())
+    if (m_timeoutEvent.IsPending())
     {
         m_timeoutEvent.Cancel();
     }
 
-    if (m_cleanDpd.IsRunning())
+    if (m_cleanDpd.IsPending())
     {
         m_cleanDpd.Cancel();
     }
@@ -442,7 +437,6 @@
 Ptr<Ipv4Interface>
 Ipv4L3Protocol::GetInterface(uint32_t index) const
 {
-    NS_LOG_FUNCTION(this << index);
     if (index < m_interfaces.size())
     {
         return m_interfaces[index];
@@ -453,14 +447,12 @@
 uint32_t
 Ipv4L3Protocol::GetNInterfaces() const
 {
-    NS_LOG_FUNCTION(this);
     return m_interfaces.size();
 }
 
 int32_t
 Ipv4L3Protocol::GetInterfaceForAddress(Ipv4Address address) const
 {
-    NS_LOG_FUNCTION(this << address);
     int32_t interface = 0;
     for (auto i = m_interfaces.begin(); i != m_interfaces.end(); i++, interface++)
     {
@@ -479,7 +471,6 @@
 int32_t
 Ipv4L3Protocol::GetInterfaceForPrefix(Ipv4Address address, Ipv4Mask mask) const
 {
-    NS_LOG_FUNCTION(this << address << mask);
     int32_t interface = 0;
     for (auto i = m_interfaces.begin(); i != m_interfaces.end(); i++, interface++)
     {
@@ -498,8 +489,6 @@
 int32_t
 Ipv4L3Protocol::GetInterfaceForDevice(Ptr<const NetDevice> device) const
 {
-    NS_LOG_FUNCTION(this << device);
-
     auto iter = m_reverseInterfacesContainer.find(device);
     if (iter != m_reverseInterfacesContainer.end())
     {
@@ -512,7 +501,6 @@
 bool
 Ipv4L3Protocol::IsDestinationAddress(Ipv4Address address, uint32_t iif) const
 {
-    NS_LOG_FUNCTION(this << address << iif);
     // First check the incoming interface for a unicast address match
     for (uint32_t i = 0; i < GetNAddresses(iif); i++)
     {
@@ -681,7 +669,6 @@
 Ptr<Icmpv4L4Protocol>
 Ipv4L3Protocol::GetIcmp() const
 {
-    NS_LOG_FUNCTION(this);
     Ptr<IpL4Protocol> prot = GetProtocol(Icmpv4L4Protocol::GetStaticProtocolNumber());
     if (prot)
     {
@@ -696,8 +683,6 @@
 bool
 Ipv4L3Protocol::IsUnicast(Ipv4Address ad) const
 {
-    NS_LOG_FUNCTION(this << ad);
-
     if (ad.IsBroadcast() || ad.IsMulticast())
     {
         return false;
@@ -726,7 +711,6 @@
 bool
 Ipv4L3Protocol::IsUnicast(Ipv4Address ad, Ipv4Mask interfaceMask) const
 {
-    NS_LOG_FUNCTION(this << ad << interfaceMask);
     return !ad.IsMulticast() && !ad.IsSubnetDirectedBroadcast(interfaceMask);
 }
 
@@ -1180,7 +1164,6 @@
 Ipv4InterfaceAddress
 Ipv4L3Protocol::GetAddress(uint32_t interfaceIndex, uint32_t addressIndex) const
 {
-    NS_LOG_FUNCTION(this << interfaceIndex << addressIndex);
     Ptr<Ipv4Interface> interface = GetInterface(interfaceIndex);
     return interface->GetAddress(addressIndex);
 }
@@ -1188,7 +1171,6 @@
 uint32_t
 Ipv4L3Protocol::GetNAddresses(uint32_t interface) const
 {
-    NS_LOG_FUNCTION(this << interface);
     Ptr<Ipv4Interface> iface = GetInterface(interface);
     return iface->GetNAddresses();
 }
@@ -1333,7 +1315,6 @@
 uint16_t
 Ipv4L3Protocol::GetMetric(uint32_t i) const
 {
-    NS_LOG_FUNCTION(this << i);
     Ptr<Ipv4Interface> interface = GetInterface(i);
     return interface->GetMetric();
 }
@@ -1341,7 +1322,6 @@
 uint16_t
 Ipv4L3Protocol::GetMtu(uint32_t i) const
 {
-    NS_LOG_FUNCTION(this << i);
     Ptr<Ipv4Interface> interface = GetInterface(i);
     return interface->GetDevice()->GetMtu();
 }
@@ -1349,7 +1329,6 @@
 bool
 Ipv4L3Protocol::IsUp(uint32_t i) const
 {
-    NS_LOG_FUNCTION(this << i);
     Ptr<Ipv4Interface> interface = GetInterface(i);
     return interface->IsUp();
 }
@@ -1398,7 +1377,6 @@
 bool
 Ipv4L3Protocol::IsForwarding(uint32_t i) const
 {
-    NS_LOG_FUNCTION(this << i);
     Ptr<Ipv4Interface> interface = GetInterface(i);
     NS_LOG_LOGIC("Forwarding state: " << interface->IsForwarding());
     return interface->IsForwarding();
@@ -1415,7 +1393,6 @@
 Ptr<NetDevice>
 Ipv4L3Protocol::GetNetDevice(uint32_t i)
 {
-    NS_LOG_FUNCTION(this << i);
     return GetInterface(i)->GetDevice();
 }
 
@@ -1433,7 +1410,6 @@
 bool
 Ipv4L3Protocol::GetIpForward() const
 {
-    NS_LOG_FUNCTION(this);
     return m_ipForward;
 }
 
@@ -1447,7 +1423,6 @@
 bool
 Ipv4L3Protocol::GetWeakEsModel() const
 {
-    NS_LOG_FUNCTION(this);
     return !m_strongEndSystemModel;
 }
 
@@ -1461,7 +1436,6 @@
 bool
 Ipv4L3Protocol::GetStrongEndSystemModel() const
 {
-    NS_LOG_FUNCTION(this);
     return m_strongEndSystemModel;
 }
 
@@ -1487,7 +1461,7 @@
     // BEWARE: here we do assume that the header options are not present.
     // a much more complex handling is necessary in case there are options.
     // If (when) IPv4 option headers will be implemented, the following code shall be changed.
-    // Of course also the reassemby code shall be changed as well.
+    // Of course also the reassembly code shall be changed as well.
 
     NS_LOG_FUNCTION(this << *packet << outIfaceMtu << &listFragments);
 
@@ -1826,7 +1800,7 @@
     }
 
     // set cleanup job for new duplicate entries
-    if (!m_cleanDpd.IsRunning() && m_purge.IsStrictlyPositive())
+    if (!m_cleanDpd.IsPending() && m_purge.IsStrictlyPositive())
     {
         m_cleanDpd = Simulator::Schedule(m_expire, &Ipv4L3Protocol::RemoveDuplicates, this);
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/internet/model/ipv4-l3-protocol.h ns-3.42/src/internet/model/ipv4-l3-protocol.h
--- ns-3.41/src/internet/model/ipv4-l3-protocol.h	2024-02-09 14:44:07.929790300 -0800
+++ ns-3.42/src/internet/model/ipv4-l3-protocol.h	2024-05-29 15:29:46.960073200 -0700
@@ -575,7 +575,7 @@
 
         /**
          * \brief Get the complete part of the packet.
-         * \return the part we have comeplete
+         * \return the part we have complete
          */
         Ptr<Packet> GetPartialPacket() const;
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/internet/model/ipv4-raw-socket-impl.cc ns-3.42/src/internet/model/ipv4-raw-socket-impl.cc
--- ns-3.41/src/internet/model/ipv4-raw-socket-impl.cc	2024-02-09 14:44:07.929790300 -0800
+++ ns-3.42/src/internet/model/ipv4-raw-socket-impl.cc	2024-05-29 15:29:46.960073200 -0700
@@ -202,7 +202,6 @@
     }
     InetSocketAddress ad = InetSocketAddress::ConvertFrom(address);
     m_dst = ad.GetIpv4();
-    SetIpTos(ad.GetTos());
     NotifyConnectionSucceeded();
 
     return 0;
@@ -228,7 +227,6 @@
 {
     NS_LOG_FUNCTION(this << p << flags);
     InetSocketAddress to = InetSocketAddress(m_dst, m_protocol);
-    to.SetTos(GetIpTos());
     return SendTo(p, flags, to);
 }
 
@@ -250,7 +248,7 @@
     Ptr<Ipv4> ipv4 = m_node->GetObject<Ipv4>();
     Ipv4Address dst = ad.GetIpv4();
     Ipv4Address src = m_src;
-    uint8_t tos = ad.GetTos();
+    uint8_t tos = GetIpTos();
 
     uint8_t priority = GetPriority();
     if (tos)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/internet/model/ipv6-extension.cc ns-3.42/src/internet/model/ipv6-extension.cc
--- ns-3.41/src/internet/model/ipv6-extension.cc	2024-02-09 14:44:07.933790200 -0800
+++ ns-3.42/src/internet/model/ipv6-extension.cc	2024-05-29 15:29:46.964073200 -0700
@@ -361,7 +361,7 @@
 
     m_fragments.clear();
     m_timeoutEventList.clear();
-    if (m_timeoutEvent.IsRunning())
+    if (m_timeoutEvent.IsPending())
     {
         m_timeoutEvent.Cancel();
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/internet/model/ipv6-extension-header.cc ns-3.42/src/internet/model/ipv6-extension-header.cc
--- ns-3.41/src/internet/model/ipv6-extension-header.cc	2024-02-09 14:44:07.933790200 -0800
+++ ns-3.42/src/internet/model/ipv6-extension-header.cc	2024-05-29 15:29:46.964073200 -0700
@@ -150,14 +150,14 @@
 uint32_t
 OptionField::GetSerializedSize() const
 {
-    return m_optionData.GetSize() + CalculatePad((Ipv6OptionHeader::Alignment){8, 0});
+    return m_optionData.GetSize() + CalculatePad(Ipv6OptionHeader::Alignment{8, 0});
 }
 
 void
 OptionField::Serialize(Buffer::Iterator start) const
 {
     start.Write(m_optionData.Begin(), m_optionData.End());
-    uint32_t fill = CalculatePad((Ipv6OptionHeader::Alignment){8, 0});
+    uint32_t fill = CalculatePad(Ipv6OptionHeader::Alignment{8, 0});
     NS_LOG_LOGIC("fill with " << fill << " bytes padding");
     switch (fill)
     {
